########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../gl.4gm/i_stdent.4gs/screen.trg  1.2  Delta: 2/9/91
########################################################################

defaults

    define  
        m_gcntrc record like stgcntrc.*,  # record holding GL control info
        p_cur_scr   smallint;
 
    do_not_generate
        lld_read;

    libraries
        ../../all.4gm/lib.a;

    after_init
        call gcontrol() returning m_gcntrc.*
        if m_gcntrc.dir_db_cr = "Y"
        then
            let p_cur_scr = 2
            open form screen1 from "stdent2"
        else
            let p_cur_scr = 1
            open form screen1 from "stdent1"
        end if;

    at_eof
############################################################
function flip()
############################################################
# if value of variable "tmpamt" is a negative amount, then 
# it flip-flops the debit_credit field

    if prev_data is null then let prev_data = 0 end if

    if p_gjourd[p_cur].tmpamt is null
      then let p_gjourd[p_cur].tmpamt=0 end if

    if p_gjourd[p_cur].tmpamt < 0
    then
        let p_gjourd[p_cur].amount=p_gjourd[p_cur].tmpamt * -1
    else
        let p_gjourd[p_cur].amount=p_gjourd[p_cur].tmpamt
    end if

    if prev_data != p_gjourd[p_cur].tmpamt
    then
        if (prev_data < 0 and p_gjourd[p_cur].tmpamt >= 0) or
           (prev_data >= 0 and p_gjourd[p_cur].tmpamt < 0)
        then
            if p_gjourd[p_cur].debit_credit = "CR"
            then
                let p_gjourd[p_cur].debit_credit = "DB"
            else
                let p_gjourd[p_cur].debit_credit = "CR"
            end if
        end if
    end if

    display p_gjourd[p_cur].* to s_gjourd[s_cur].*

end function
# flip()

############################################################
function fill_grp_key()
############################################################
# selects distributions from the general distribution file
# and fills in the detail lines based on what it finds.
#

    define
        tmp_line_no   smallint,
        counter   smallint

    for counter = 1 to scr1_max
        clear s_gjourd[counter].*
    end for

    let rec1_cnt = rec1_max
    call mld_clear()

    display by name p_gstder.grp_desc,p_gstder.grp_key

    let counter = 1

    declare j_curs cursor for
        select line_no, acct_no, department
            from stxactgd
                where stxactgd.grp_key = p_gstder.grp_key
                     order by line_no

        foreach j_curs into tmp_line_no,
                        p_gjourd[counter].acct_no,
                        p_gjourd[counter].department
        call al_chrtn(p_gjourd[counter].acct_no)
                         returning p_gjourd[counter].acct_desc,
                                   p_gjourd[counter].debit_credit
        let counter = counter + 1
    end foreach

    let rec1_cnt = counter - 1
    call set_count(rec1_cnt)

    call lld_recalc()
    call lld_display()

end function
# fill_grp_key();

input 1

    on_disk_record_prep
        let m_gstder.file_type = "SJ";

    before_field post_type
        if p_gstder.post_type is null
          then let p_gstder.post_type = "N" end if;

    before_field eop_rev
        if p_gstder.eop_rev is null
          then let p_gstder.eop_rev = "N" end if;

    after_field post_type
        if (p_gstder.post_type != "Y" and 
            p_gstder.post_type != "N" and
            p_gstder.post_type != "A") or
            p_gstder.post_type is null
        then 
            let p_gstder.post_type = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "post_type"
            return
        end if;

    after_field eop_rev
        if (p_gstder.eop_rev != "Y" and 
            p_gstder.eop_rev != "N") or
            p_gstder.eop_rev is null
        then 
            let p_gstder.eop_rev = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "eop_rev"
            return
        end if;

    after_field grp_key
        if rec1_cnt = 0 and not data_changed
          then call fill_grp_key() end if;

    after_change_in grp_key
        call fill_grp_key();

    after_field doc_src
        call prep_doc_src();

    after_input
        if (p_gstder.eop_rev != "Y" and p_gstder.eop_rev != "N") or
            p_gstder.eop_rev is null
          then let p_gstder.eop_rev = "N" end if
    
        if p_gstder.post_type != "Y" and p_gstder.post_type != "N" and
           p_gstder.post_type != "A"
          then let p_gstder.post_type = "N" end if

       call prep_doc_src()

        if not tab_pressed
        then
            call lld_chk_p_array()
            if rec1_cnt = 0 
            then 
                call fg_err(2) # Document must have detail line(s).
                let tab_pressed = true
                return
            end if
        end if;

    at_eof
######################################################################
function prep_doc_src()
# after field logic for the header field doc_src
######################################################################
# 
 
    if p_gstder.doc_src is null
    then
        let p_gstder.doc_src = "GENJRN"
        if llh_lookup("src_look",true) = false
        then
            insert into stxinfor
                values("S","GENJRN","GENERAL JOURNAL","","","")
            let p_gstder.src_desc = "GENERAL JOURNAL"
        end if
    end if
                        
end function
# prep_doc_src;

input 2

    define
        incr_with_crdt   char(1);
 
    before_insert   
        let scr_fld = null;

    on_screen_record_prep
        if m_gjourd.debit_credit = "C"
        then
            let p_gjourd[n].debit_credit = "CR"
        else
            let p_gjourd[n].debit_credit = "DB"
        end if
        if p_cur_scr = 1
        then
            if (q_gjourd[n].incr_with_crdt = "Y"
                and p_gjourd[n].debit_credit = "CR")
              or (q_gjourd[n].incr_with_crdt = "N"
                  and p_gjourd[n].debit_credit = "DB")
            then
                let p_gjourd[n].tmpamt = p_gjourd[n].amount
            else
                let p_gjourd[n].tmpamt = p_gjourd[n].amount * -1
            end if
        end if;

    on_disk_record_prep
        let m_gjourd.orig_journal = "SJ"
        let m_gjourd.debit_credit = p_gjourd[n].debit_credit[1,1];

    after_change_in acct_no
        call fgda_acct_no();

    after_field department
        call fgda_department();

    after_change_in amount
        call fgda_amount();

    after_change_in debit_credit
        call fgda_credit_debit();

    after_change_in tmpamt
        call fgda_tmpamt();

    after_delete
        call lld_recalc();

    after_input
        if not tab_pressed
        then
            call lld_chk_p_array()
            if rec1_cnt = 0 
            then 
                call fg_err(2) # Document must have detail line(s).
                let nxt_fld = "goto top"
                return
            end if
        end if
        call lld_recalc()
        if p_gstder.diff <> 0
        then
            open window diffwin at 19, 8 with 1 rows, 66 columns
            attribute (border, white)
            let scratch = " Credit= ",p_gstder.crtotal
            let scratch = scratch clipped," Debit= ",p_gstder.dbtotal
            let scratch = scratch clipped," Diff= ",p_gstder.diff
            display scratch at 1,2 attribute(white)
            call fg_err(1) # Credits and Debits are not balance
            close window diffwin
            let nxt_fld = "goto top"
        end if;

    at_eof
######################################################################
function fgda_acct_no()
# after field logic for the detail field acct_no
######################################################################
# 
 
    if p_gjourd[p_cur].acct_no is null
    then
        initialize p_gjourd[p_cur].* to null
        initialize q_gjourd[p_cur].* to null
    else
        let p_gjourd[p_cur].amount = null
        let p_gjourd[p_cur].tmpamt = null
    end if
    call lld_recalc()
    if q_gjourd[p_cur].incr_with_crdt is not null
    then
        if q_gjourd[p_cur].incr_with_crdt = "Y"
          then let p_gjourd[p_cur].debit_credit = "CR"
          else let p_gjourd[p_cur].debit_credit = "DB" end if
    end if

end function
# fgda_acct_no

######################################################################
function fgda_department()
# after field logic for the detail field department
######################################################################
# 
 
    if p_gjourd[p_cur].acct_no is not null and
       p_gjourd[p_cur].department is null
    then
        let p_gjourd[p_cur].department = "000"
        display p_gjourd[p_cur].department
             to s_gjourd[s_cur].department
    end if

end function
# fgda_department

######################################################################
function fgda_amount()
# after field logic for the detail field amount
######################################################################
# 
 
    let p_gjourd[p_cur].amount = round("a", p_gjourd[p_cur].amount)
    let p_gjourd[p_cur].amount = absolute(p_gjourd[p_cur].amount)

    if p_gjourd[p_cur].acct_no is not null and
       p_gjourd[p_cur].department is not null
    then
        call lld_recalc()
    else
        initialize p_gjourd[p_cur].* to null
        display p_gjourd[p_cur].* to s_gjourd[s_cur].*
    end if

end function
# fgda_amount

######################################################################
function fgda_credit_debit()
# after field logic for the detail field credit_debit
######################################################################
# 
 
    if p_gjourd[p_cur].acct_no is not null
    then
       if (p_gjourd[p_cur].debit_credit = "DB" or 
           p_gjourd[p_cur].debit_credit = "CR")
       then
           call lld_recalc()
       else
           call fg_err(4)  # Invalid entry
           let nxt_fld = "debit_credit"
       end if
    end if

end function
# fgda_credit_debit

######################################################################
function fgda_tmpamt()
# after field logic for the detail field tmpamt
######################################################################
# 
 
    let p_gjourd[p_cur].tmpamt = round("a",
        p_gjourd[p_cur].tmpamt)

    if p_gjourd[p_cur].acct_no is not null and
       p_gjourd[p_cur].department is not null
    then
        call flip()
        call lld_recalc()
    else
        initialize p_gjourd[p_cur].* to null
        display p_gjourd[p_cur].* to s_gjourd[s_cur].*
    end if

end function
# fgda_tmpamt

############################################################
function lld_recalc()
#     returns the difference between the debits and credits
############################################################
# Recalculate totals of debits and credits found on bottom
# of screen.
#

    define
        counter             smallint,
        tot_credit          like stgjourd.amount,
        tot_debit           like stgjourd.amount,
        tot_diff            like stgjourd.amount

    let tot_credit = 0
    let tot_debit = 0
    let tot_diff = 0
   
    for counter = 1 to rec1_cnt
      if p_gjourd[counter].amount is not null then
          if p_gjourd[counter].debit_credit = "CR" then
              let tot_credit=p_gjourd[counter].amount + tot_credit
          else
              let tot_debit=p_gjourd[counter].amount + tot_debit
          end if
      end if
    end for

    let tot_diff = tot_credit - tot_debit
    if tot_diff < 0
    then
        let tot_diff = tot_diff * -1
    end if

    let p_gstder.crtotal = tot_credit
    let p_gstder.dbtotal = tot_debit
    let p_gstder.diff = tot_diff

    call llh_display()

end function
# lld_recalc()

#######################################################################
function lld_chk_p_array()
#######################################################################
#   - this function removes lines that are null or zero
#
    define
        num_in smallint,     # outer loop counter
        n smallint,     # inner loop counter
        num_out smallint      # inner loop counter

    let num_in = 0
    let num_out = 0
    for n = 1 to rec1_cnt
      if p_gjourd[n].amount is null or p_gjourd[n].amount = 0
      then
          let num_out = num_out + 1
          continue for
      end if
      let num_in = num_in + 1
      let p_gjourd[num_in].* = p_gjourd[n].*
      let q_gjourd[num_in].* = q_gjourd[n].*
    end for
    initialize p_gjourd[num_in + 1].* to null
    initialize q_gjourd[num_in + 1].* to null
    for n = (num_in + 2) to rec1_cnt
      let p_gjourd[n].* = p_gjourd[num_in + 1].*
      let q_gjourd[n].* = q_gjourd[num_in + 1].*
    end for
    let rec1_cnt = num_in
    call lld_display()

end function
# lld_chk_p_array();
